function results = property_match(values,query)

values = values(strlength(values)>0);
hinters = {};
for k=1:length(values)
    %temp = split(values(k),[" ","_"]);
    temp = replace(values(k),'-',' ');
    temp = replace(temp,'!',' ');
    temp = replace(temp,',',' ');
    temp = replace(temp,'_',' ');
    temp = replace(temp,'''s',' ');
    temp = replace(temp,'&',' ');
    temp = replace(temp,'''',' ');
    temp = regexprep(temp,' +',' ');
    temp = strip(temp);

    temp = split(temp," ");
    hinters{k} = setdiff(lower(temp),stopWords);
end

% uses a word frequency count to score matches, i.e matches
% containing common words as restaurant or cafe get lower scores
wrdlist=""; 
for k=1:length(hinters)
    wrdlist = [wrdlist;unique(hinters{k})]; 
end
[wrds,~,idxs] = unique(wrdlist(2:end));
wrdfreqs = hist(idxs,length(wrds));

query = replace(query,'!',' ');
query = replace(query,',',' ');
query = replace(query,'-',' ');
query = replace(query,'_',' ');
query = replace(query,'''s',' ');
query = replace(query,'&',' ');
query = replace(query,'''',' ');
query = regexprep(query,' +',' ');
query = strip(query);

query = string(tokenizedDocument(query));
nmatch = []; extracted = string(); entity=[]; counter=0;
for k=1:length(hinters)
    %matches = contains(query,hinters{k},'IgnoreCase',true);
    m1 = endsWith(query,hinters{k},'IgnoreCase',true);
    m2 = startsWith(query,hinters{k},'IgnoreCase',true);
    matches = m1.*m2;
    if sum(matches)==0, continue; end
    idx = find(matches);
    %if length(idx)==1
    %    check = contains(query(idx),["restaurant","cafe"],'IgnoreCase',true);
    %    if sum(check)>0, continue; end
    %end
    %if sum(matches(idx(1):idx(end))==0)>2, continue; end
    counter = counter+1;
    segment = query(idx(1):idx(end));
    extracted(counter) = join(segment);
    entity(counter)=k;
    score = 0;
    for n=1:length(idx)
        widx = find(wrds==lower(query(idx(n))));
        if isempty(widx)
            disp(query(idx(n))); 
            disp('ERROR!'); 
            continue; 
        end
        score = score+1/wrdfreqs(widx);
    end
    
    nwvalue = length(hinters{k});
    nwmatch = idx(end)-idx(1)+1;
    lengthpenalty = 1/sqrt(1+abs(nwvalue-nwmatch));
    nmatch(counter) = score*lengthpenalty;
    %nmatch(counter) = sum(matches)*strlength(extracted(counter));
end

results = table();
if not(isempty(nmatch))
    [sortmatch,sortidx] = sort(nmatch,'descend');
    results.match = extracted(sortidx)';
    results.value = replace(values(entity(sortidx)),' ','_');
    results.score = sortmatch';
end

% if not(isempty(nmatch))
%     [~,idx] = max(nmatch);
%     property = values(entity(idx));
%     match = extracted(idx);
% else
%     property = "";
%     match = "";
% end

return