function [value,response,goals] = user_response(systemquery,goals)

if isempty(fields(goals))
    load datasets_ch15
    tbl = struct2table(data);
    restaurants = tbl.restaurant;
    cuisines = setdiff(unique(tbl.cuisine),"");
    prices = unique(tbl.price);
    locations = unique(tbl.location);
    idx = randi(length(restaurants));
    myfood = setdiff(unique(tbl.cuisine(idx)),"");
    
    randfood = randi(100);
    if randfood>20
        goals.myfood = myfood(randi(length(myfood)));
    elseif randfood<10
        goals.myfood = cuisines(randi(length(cuisines)));
    else
        goals.myfood = "Any_type";
    end
    
    randcity = randi(100);
    if randcity>20
        goals.mycity = tbl.location(idx);
    elseif randcity<10
        goals.mycity = locations(randi(length(locations)));
    else
        goals.mycity = "Any_city";
    end
    
    randprice = randi(100);
    if randprice>20
        goals.myprice = tbl.price(idx);
    elseif randprice<10
        goals.myprice = prices(randi(length(prices)));
    else
        goals.myprice = "Any_price";
    end
end

if contains(systemquery,"food")
    response = goals.myfood;
    
elseif contains(systemquery,"city")
    response = goals.mycity;

elseif contains(systemquery,"price")
    response = goals.myprice;
        
else
    response = "Thanks!";
end

value = response;

if response{1}(1)>'Z'
    response{1}(1)=response{1}(1)-32;
end

response = replace(response,'_',' ');
return

